window.onload = function(){
	initUi();
	initInputTip();
	bindClick($('ok'), ok);
	bindEvent($('server'), 'keydown', function(e){
		if (e.keyCode == 13) ok();
	});
};

/**
 * 点击“完成”按钮执行的方法
 */
function ok(){
	var okBtn = $('ok'),
		value = trim($('server').value);
	if (okBtn.className == 'disabled') return;
	if (value == '' || $('server').className == 'hint') {
		showMsg('请输入服务器地址');
		return;
	}
	setDisabled(true);
	showMsg('连接中，请稍候...');
	saveServerAddr(value);
}

/**
 * 保存服务器地址
 * @param addr
 */
function saveServerAddr(addr){
	if (addr.indexOf('http://') != 0 && addr.indexOf('https://') != 0) {
		addr = 'http://' + addr;
	}
	var testUrl = addr + '/sys/util/na/is-guwee-server';
	console.log("testUrl", testUrl);
	ajax(testUrl, function(value){
		if (window.client){
			client.setServerUrl(addr);
		} else {
			showMsg(addr);
		}
		setDisabled(false);
	}, function(status){
	console.log("status", status)
		showMsg('服务器地址不正确或不可用');
		setDisabled(false);
	});
}

function setDisabled(disabled){
	if (disabled) {
		$('ok').className = 'disabled';
		$('server').disabled = true;
	} else {
		$('ok').className = '';
		$('server').disabled = false;
	}
}

function initUi(){
	if (location.href.indexOf('?notFirst') == -1) {
		$('welcome').style.display = 'block';
	} else {
		$('cancel').style.display = 'inline';
		$('server').style.marginTop = '12px';
		bindClick($('cancel'), function(){
			history.back();
		});
	}
}

function initInputTip(){
	var input = $('server'),
		oldSvrUrl = window.client && client.getServerUrl(),
		blur = function(){
			if (trim(input.value) == ''){
				input.value = '输入服务器地址';
				input.className = 'hint';
			}
		};
	if (oldSvrUrl) input.value = oldSvrUrl.replace(/^http:\/\//,'').replace(/\/$/,'');
	bindEvent(input, 'focus', function(){
		if (input.className == 'hint') {
			input.value = '';
			input.className = '';
		}
	});
	bindEvent(input, 'blur', blur);
	bindEvent(input, 'input', function(){ showMsg(''); });
	blur();
}

function getBaseUrl() {
	return window.client ? client.getBaseUrl() : 'http://localhost/itsm';
}

function showMsg(msg){
	$('error-msg').innerText = msg;
}

function $(id) {
	return document.getElementById(id);
}

function bindClick(element, fn){
	if (window.client){
		bindEvent(element, 'touchstart', function(e){
			setTimeout(function(){
				element.className = 'pressed';
			}, 10);
		});
		bindEvent(element, 'touchend', function(e){
			setTimeout(function(){
				element.className = '';
				fn(e);
			}, 100);
		});
	} else {
		bindEvent(element, 'click', fn);
	}
}

function bindEvent(element, event, fn){
	if (element.addEventListener) {
		element.addEventListener(event, fn);
	} else if (element.attachEvent) {
		element.attachEvent( "on" + event, fn);
	}
}

function ajax(url, success, error){
	var http = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP'),
		timeout = setTimeout(function(){
			http.abort();
		}, 10000);
		console.log("test1");
	http.onreadystatechange = function() {
		console.log("test2", http.status);
		if (http.readyState == 4) {
			clearTimeout(timeout);
			if ( http.status == 200 || http.status == 0) {
				success && success(http.responseText);
			} else {
				error && error(http.status);
			}
		}
	};
		console.log("test3");
	http.open('GET', url, true);
		console.log("test4");
	http.send();
}

function trim(str){
	return str ? str.replace(/^\s+|\s+$/g, '') : str;
}
